package com.casic.dcms.view.statistics;

import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.RadioGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.adapter.NormalRecyclerAdapter;
import com.casic.dcms.databinding.ActivityCaseResourceBinding;
import com.casic.dcms.model.CaseResourceBean;
import com.casic.dcms.utils.ChartViewHelper;
import com.casic.dcms.utils.ColorKit;
import com.casic.dcms.utils.LocaleConstant;
import com.casic.dcms.utils.TimeOrDateUtil;
import com.casic.dcms.utils.ViewGroupKit;
import com.casic.dcms.vm.DataAnalysisViewModel;
import com.casic.dcms.widgets.RangeDateActionSheet;
import com.github.mikephil.charting.data.PieEntry;
import com.pengxh.androidx.lite.adapter.ViewHolder;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.divider.RecyclerViewItemDivider;
import com.pengxh.androidx.lite.kit.LongKit;
import com.pengxh.androidx.lite.utils.LoadState;
import com.pengxh.androidx.lite.utils.LoadingDialog;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class CaseResourceActivity extends AndroidxBaseActivity<ActivityCaseResourceBinding> {

    private static final String TAG = "CaseResourceActivity";
    private final Context context = CaseResourceActivity.this;
    private DataAnalysisViewModel dataAnalysisViewModel;

    @Override
    protected void setupTopBarLayout() {
        ViewGroupKit.initImmersionBar(binding.rootView, this, true, R.color.white);

        binding.titleBarLayout.titleView.setText(LocaleConstant.ANALYSIS_ITEMS.get(1));
        binding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        dataAnalysisViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    LoadingDialog.show(CaseResourceActivity.this, "数据加载中，请稍后");
                } else {
                    LoadingDialog.dismiss();
                }
            }
        });
    }

    @Override
    protected void initOnCreate(@Nullable Bundle savedInstanceState) {
        dataAnalysisViewModel = new ViewModelProvider(this).get(DataAnalysisViewModel.class);
        dataAnalysisViewModel.caseResourceData.observe(this, new Observer<CaseResourceBean>() {
            @Override
            public void onChanged(CaseResourceBean caseResourceBean) {
                if (caseResourceBean.getCode() == 200) {
                    int caseCount = 0;
                    List<CaseResourceBean.DataModel> dataModels = caseResourceBean.getData();

                    //排序
                    Collections.sort(dataModels, new CaseResourceComparator());

                    List<PieEntry> pieEntries = new ArrayList<>();
                    for (CaseResourceBean.DataModel dataModel : dataModels) {
                        caseCount += Integer.parseInt(dataModel.getCaseNum());

                        if (!dataModel.getCaseNum().equals("0")) {
                            pieEntries.add(new PieEntry(Float.parseFloat(dataModel.getCaseNum()), dataModel.getCaseSource()));
                        }
                    }
                    binding.caseCountView.setText("案卷数：" + caseCount);

                    //数据绑定饼图
                    ChartViewHelper.setPieChartData(binding.resourcePieChart, pieEntries);

                    //绑定列表
                    NormalRecyclerAdapter<CaseResourceBean.DataModel> recyclerAdapter = new NormalRecyclerAdapter<CaseResourceBean.DataModel>(R.layout.item_case_resource_lv_l, dataModels) {
                        @Override
                        public void convertView(ViewHolder viewHolder, int position, CaseResourceBean.DataModel item) {
                            //设置随机颜色
                            int[] color = ColorKit.generateColor(context);

                            viewHolder.setText(R.id.numberTagView, String.valueOf(position + 1))
                                    .setBackgroundColor(R.id.numberTagView, color[0])
                                    .setTextColor(R.id.numberTagView, color[1])
                                    .setText(R.id.caseSourceView, item.getCaseSource())
                                    .setText(R.id.caseNumView, item.getCaseNum());
                        }
                    };
                    binding.caseResourceView.addItemDecoration(new RecyclerViewItemDivider(1, Color.LTGRAY));
                    binding.caseResourceView.setAdapter(recyclerAdapter);
                }
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
        //默认加载当前时间往前一个月的
        dataAnalysisViewModel.getCaseResource(this, TimeOrDateUtil.getOneMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
    }

    @Override
    protected void initEvent() {
        binding.selectCalendarButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new RangeDateActionSheet.Builder().setContext(context).setOnActionSheetListener(new RangeDateActionSheet.OnDateRangeSelectedListener() {
                    @Override
                    public void onDateRangeSelected(String startDate, String endDate) {
                        dataAnalysisViewModel.getCaseResource(context, startDate, endDate);
                    }
                }).build().show();
            }
        });

        binding.radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (checkedId == R.id.oneMonthRadioButton) {
                    dataAnalysisViewModel.getCaseResource(context, TimeOrDateUtil.getOneMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
                } else if (checkedId == R.id.threeMonthRadioButton) {
                    dataAnalysisViewModel.getCaseResource(context, TimeOrDateUtil.getThreeMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
                } else {
                    dataAnalysisViewModel.getCaseResource(context, TimeOrDateUtil.getSixMonthDate(), LongKit.timestampToDate(System.currentTimeMillis()));
                }
            }
        });
    }

    private static class CaseResourceComparator implements Comparator<CaseResourceBean.DataModel> {

        @Override
        public int compare(CaseResourceBean.DataModel o1, CaseResourceBean.DataModel o2) {
            int i = Integer.parseInt(o1.getCaseNum());
            int j = Integer.parseInt(o2.getCaseNum());
            return j - i;
        }
    }
}
